#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sysexits.h>


#include "hotswap.h"

#define usage() fputs("usage: hotswap [-u] [-s syscall] [fd<ctrl>:<drive>] [ide<ctrl>:<channel>]\n",stderr);

int main(int argc,char **argv)
{
	int	c,call = -1,unload = 0,
		ctrl,unit,err = 0;
	char	*p;

	while ((c=getopt(argc,argv,"us:")) != -1) switch (c) {
		case 's': call = atoi(optarg); break;
		case 'u': unload = 1; break;
		default: usage(); return EX_USAGE;
	}

	if (call == -1) {
		char	*c = getenv("HOTSWAP_SYS");
		if (!c) {
			usage();
			return EX_USAGE;
		}
		call = atoi(c);
	}

	if (argc == optind) { usage(); return EX_USAGE; }

	while (optind < argc) {
		if (strncmp(argv[optind],"fd",2) == 0) {
			ctrl = unit = 0;
			ctrl = atoi(argv[optind]+2);
			p = strchr(argv[optind],':');
			if (p) unit = atoi(p+1);

			if (syscall(call,
				unload ? HOTSWAP_OUT_FD : HOTSWAP_IN_FD,
				ctrl,unit))
			{
				perror("syscall()");
				if (!err) err = EX_OSERR;
			}
		}
		else if (strncmp(argv[optind],"ide",3)==0) {
			ctrl = 0; unit = 1;
			ctrl = atoi(argv[optind+3]);
			p = strchr(argv[optind],':');
			if (p) unit = atoi(p+1);

			if (syscall(call,
				unload ? HOTSWAP_OUT_CD : HOTSWAP_IN_CD,
				ctrl,unit))
			{
				perror("syscall()");
				if (!err) err = EX_OSERR;
			}
		}
		else {
			usage();
			if (!err) err = EX_USAGE;
		}
		optind++;
	}
	return err;
}
